Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.caucho.xml
Class AbstractParser

    java.lang.Object
      |
      +--com.caucho.xml.AbstractParser

All Implemented Interfaces:
  org.xml.sax.Parser, org.xml.sax.XMLReader

Direct Known Subclasses:
  XmlParser

public abstract class AbstractParser
extends java.lang.Object
implements org.xml.sax.XMLReader, org.xml.sax.Parser

Method Summary
`org.xml.sax.ContentHandler` | `getContentHandler()` Return the current content handler.
`java.lang.String` | `getDefaultEncoding()` Gets the default encoding if none is specified.
`org.xml.sax.DTDHandler` | `getDTDHandler()` Return the current DTD handler.
`boolean` | `getEntitiesAsText()`
`org.xml.sax.EntityResolver` | `getEntityResolver()` Sets the callback object finding files from system ids.
`org.xml.sax.ErrorHandler` | `getErrorHandler()` Return the current error handler.
`boolean` | `getFeature(java.lang.String name)` Look up the value of a feature.
`boolean` | `getForgiving()` Returns true if the parser is forgiving.
`boolean` | `getJsp()` Returns true if the parser should handle special JSP forgiveness.
`java.lang.Object` | `getProperty(java.lang.String name)` Look up the value of a property.
`boolean` | `getResinInclude()` Returns true if resin:include will include other XML documents.
`Path` | `getSearchPath()` Gets the search path for included documents.
`boolean` | `getSkipComments()`
`boolean` | `isCoalescing()` Returns true if text and cdata nodes will be combined.
`java.io.InputStream` | `openStream(java.lang.String systemId, java.lang.String publicId)` Looks up an input stream from the system id.
`void` | `parse(org.xml.sax.InputSource source)` SAX parsing from a SAX InputSource
`void` | `parse(java.io.InputStream is)` SAX parsing from an InputStream
`void` | `parse(java.io.InputStream is, java.lang.String systemId)` SAX parsing from an InputStream
`void` | `parse(Path path)` SAX parsing from a VFS path
`void` | `parse(java.lang.String systemId)` SAX parsing from a file path
`Document` | `parseDocument(org.xml.sax.InputSource source)` Parses a document from a SAX InputSource
`Document` | `parseDocument(java.io.InputStream is)` Parses an input stream into a DOM document
`Document` | `parseDocument(java.io.InputStream is, java.lang.String systemId)` Parses an input stream into a DOM document
`Document` | `parseDocument(Path path)` Parses a document from a VFS path
`Document` | `parseDocument(java.lang.String systemId)` Parses a document from system path.
`Document` | `parseDocumentString(java.lang.String string)` Parses a string into a DOM document
`void` | `parseString(java.lang.String string)` SAX parsing from a string.
`void` | `setAutodetectXml(boolean autodetectXml)` Set true if the parser should switch from HTML to XML if it detects the <?xml ?> header.
`void` | `setCoalescing(boolean isCoalescing)` Set true if text and cdata nodes should be combined.
`void` | `setConfig(DocumentBuilderFactory factory)` Sets the configuration for a document builder.
`void` | `setContentHandler(org.xml.sax.ContentHandler handler)` Allow an application to register a content event handler.
`void` | `setDefaultEncoding(java.lang.String encoding)` Sets the default encoding if none is specified.
`void` | `setDocumentHandler(org.xml.sax.DocumentHandler handler)` Configures the document handler callback.
`void` | `setDTDHandler(org.xml.sax.DTDHandler handler)` Allow an application to register a DTD event handler.
`void` | `setEntitiesAsText(boolean entitiesAsText)`
`void` | `setEntityResolver(org.xml.sax.EntityResolver resolver)` Sets the callback object to find files.
`void` | `setErrorHandler(org.xml.sax.ErrorHandler handler)` Allow an application to register an error event handler.
`void` | `setExpandEntities(boolean expandEntities)`
`void` | `setFeature(java.lang.String name, boolean value)` Set the state of a feature.
`void` | `setForgiving(boolean forgiving)` Sets the parser as a forgiving parser, allowing some non-strict XML.
`void` | `setJsp(boolean isJsp)` Sets the parser to handle special JSP forgiveness.
`void` | `setLocale(java.util.Locale locale)` Allow an application to request a locale for errors and warnings.
`void` | `setProperty(java.lang.String name, java.lang.Object obj)` Set the value of a property.
`void` | `setResinInclude(boolean doResinInclude)` Enables including of other XML documents with resin:include.
`void` | `setSearchPath(Path path)` Sets the search path for included documents.
`void` | `setSkipComments(boolean skipComments)` Set to true if comments should be skipped.
`void` | `setSkipWhitespace(boolean skipWhitespace)` Set to true if ignorable-whitespace should be skipped.
`void` | `setToLower(boolean toLower)` If true, normalizes HTML tags to lower case.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### setConfig

    public void setConfig(DocumentBuilderFactory factory)

  Sets the configuration for a document builder.

### setEntitiesAsText

    public void setEntitiesAsText(boolean entitiesAsText)

### getEntitiesAsText

    public boolean getEntitiesAsText()

### setExpandEntities

    public void setExpandEntities(boolean expandEntities)

### setSkipComments

    public void setSkipComments(boolean skipComments)

  Set to true if comments should be skipped. If false events will be generated for the comments.

### setSkipWhitespace

    public void setSkipWhitespace(boolean skipWhitespace)

  Set to true if ignorable-whitespace should be skipped.

### isCoalescing

    public boolean isCoalescing()

  Returns true if text and cdata nodes will be combined.

### setCoalescing

    public void setCoalescing(boolean isCoalescing)

  Set true if text and cdata nodes should be combined.

### setToLower

    public void setToLower(boolean toLower)

  If true, normalizes HTML tags to lower case.

### getSkipComments

    public boolean getSkipComments()

### setForgiving

    public void setForgiving(boolean forgiving)

  Sets the parser as a forgiving parser, allowing some non-strict XML.
  Parameters:
    `forgiving` - if true, forgives non-strict XML.

### getForgiving

    public boolean getForgiving()

  Returns true if the parser is forgiving.
  Returns:
    true if the parser forgives non-strict XML.

### setAutodetectXml

    public void setAutodetectXml(boolean autodetectXml)

  Set true if the parser should switch from HTML to XML if it detects the <?xml ?> header.

### setJsp

    public void setJsp(boolean isJsp)

  Sets the parser to handle special JSP forgiveness.
  Parameters:
    `isJsp` - if true, handles special JSP forgiveness.

### getJsp

    public boolean getJsp()

  Returns true if the parser should handle special JSP forgiveness.
  Returns:
    true if handles special JSP forgiveness.

### setSearchPath

    public void setSearchPath(Path path)

  Sets the search path for included documents. MergePaths are often used.
  Parameters:
    `path` - the path to search

### getSearchPath

    public Path getSearchPath()

  Gets the search path for included documents. MergePaths are often used.
  Returns:
    the path to search

### setDefaultEncoding

    public void setDefaultEncoding(java.lang.String encoding)

  Sets the default encoding if none is specified.
  Parameters:
    `encoding` - the default encoding

### getDefaultEncoding

    public java.lang.String getDefaultEncoding()

  Gets the default encoding if none is specified.

### setResinInclude

    public void setResinInclude(boolean doResinInclude)

  Enables including of other XML documents with resin:include.
  Parameters:
    `doResinInclude` - if true, enables the include.

### getResinInclude

    public boolean getResinInclude()

  Returns true if resin:include will include other XML documents.
  Parameters:
    `doResinInclude` - if true, enables the include.

### getProperty

    public java.lang.Object getProperty(java.lang.String name)
                                 throws org.xml.sax.SAXNotRecognizedException

  Description copied from interface: `org.xml.sax.XMLReader`
  Look up the value of a property.

  The property name is any fully-qualified URI. It is possible for an XMLReader to recognize a property name but to be unable to return its state; this is especially true in the case of an adapter for a SAX1 `Parser`.

  XMLReaders are not required to recognize any specific property names, though an initial core set is documented for SAX2.

  Some property values may be available only in specific contexts, such as before, during, or after a parse.

  Implementors are free (and encouraged) to invent their own properties, using names built on their own URIs.

  Specified by:
    `getProperty` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Parameters:
    `name` - The property name, which is a fully-qualified URI.
  Returns:
    The current value of the property.
  Throws:
    `org.xml.sax.SAXNotRecognizedException` - When the XMLReader does not recognize the property name.
    `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the property name but cannot determine its value at this time.
  See Also:
    `XMLReader.setProperty(java.lang.String, java.lang.Object)`

### setProperty

    public void setProperty(java.lang.String name,
                            java.lang.Object obj)
                     throws org.xml.sax.SAXNotSupportedException

  Description copied from interface: `org.xml.sax.XMLReader`
  Set the value of a property.

  The property name is any fully-qualified URI. It is possible for an XMLReader to recognize a property name but to be unable to set its value; this is especially true in the case of an adapter for a SAX1 `Parser`.

  XMLReaders are not required to recognize setting any specific property names, though a core set is provided with SAX2.

  Some property values may be immutable or mutable only in specific contexts, such as before, during, or after a parse.

  This method is also the standard mechanism for setting extended handlers.

  Specified by:
    `setProperty` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Parameters:
    `name` - The property name, which is a fully-qualified URI.
    `state` - The requested value for the property.
  Throws:
    `org.xml.sax.SAXNotRecognizedException` - When the XMLReader does not recognize the property name.
    `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the property name but cannot set the requested value.

### getFeature

    public boolean getFeature(java.lang.String name)
                       throws org.xml.sax.SAXNotRecognizedException

  Description copied from interface: `org.xml.sax.XMLReader`
  Look up the value of a feature.

  The feature name is any fully-qualified URI. It is possible for an XMLReader to recognize a feature name but to be unable to return its value; this is especially true in the case of an adapter for a SAX1 Parser, which has no way of knowing whether the underlying parser is performing validation or expanding external entities.

  All XMLReaders are required to recognize the http://xml.org/sax/features/namespaces and the http://xml.org/sax/features/namespace-prefixes feature names.

  Some feature values may be available only in specific contexts, such as before, during, or after a parse.

  Typical usage is something like this:

       XMLReader r = new MySAXDriver();

                               // try to activate validation
       try {
         r.setFeature("http://xml.org/sax/features/validation", true);
       } catch (SAXException e) {
         System.err.println("Cannot activate validation.");
       }

                               // register event handlers
       r.setContentHandler(new MyContentHandler());
       r.setErrorHandler(new MyErrorHandler());

                               // parse the first document
       try {
         r.parse("http://www.foo.com/mydoc.xml");
       } catch (IOException e) {
         System.err.println("I/O exception reading XML document");
       } catch (SAXException e) {
         System.err.println("XML exception reading document.");
       }

  Implementors are free (and encouraged) to invent their own features, using names built on their own URIs.

  Specified by:
    `getFeature` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Parameters:
    `name` - The feature name, which is a fully-qualified URI.
  Returns:
    The current state of the feature (true or false).
  Throws:
    `org.xml.sax.SAXNotRecognizedException` - When the XMLReader does not recognize the feature name.
    `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the feature name but cannot determine its value at this time.
  See Also:
    `XMLReader.setFeature(java.lang.String, boolean)`

### setFeature

    public void setFeature(java.lang.String name,
                           boolean value)
                    throws org.xml.sax.SAXNotSupportedException

  Description copied from interface: `org.xml.sax.XMLReader`
  Set the state of a feature.

  The feature name is any fully-qualified URI. It is possible for an XMLReader to recognize a feature name but to be unable to set its value; this is especially true in the case of an adapter for a SAX1 `Parser`, which has no way of affecting whether the underlying parser is validating, for example.

  All XMLReaders are required to support setting http://xml.org/sax/features/namespaces to true and http://xml.org/sax/features/namespace-prefixes to false.

  Some feature values may be immutable or mutable only in specific contexts, such as before, during, or after a parse.

  Specified by:
    `setFeature` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Parameters:
    `name` - The feature name, which is a fully-qualified URI.
    `state` - The requested state of the feature (true or false).
  Throws:
    `org.xml.sax.SAXNotRecognizedException` - When the XMLReader does not recognize the feature name.
    `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the feature name but cannot set the requested value.
  See Also:
    `XMLReader.getFeature(java.lang.String)`

### setEntityResolver

    public void setEntityResolver(org.xml.sax.EntityResolver resolver)

  Sets the callback object to find files.
  Specified by:
    `setEntityResolver` in interface `org.xml.sax.XMLReader`
  Parameters:
    `resolver` - the object to find files.

### getEntityResolver

    public org.xml.sax.EntityResolver getEntityResolver()

  Sets the callback object finding files from system ids.
  Specified by:
    `getEntityResolver` in interface `org.xml.sax.XMLReader`
  Returns:
    the resolver to find files.

### setDTDHandler

    public void setDTDHandler(org.xml.sax.DTDHandler handler)

  Description copied from interface: `org.xml.sax.XMLReader`
  Allow an application to register a DTD event handler.

  If the application does not register a DTD handler, all DTD events reported by the SAX parser will be silently ignored.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setDTDHandler` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Parameters:
    `handler` - The DTD handler.
  Throws:
    `java.lang.NullPointerException` - If the handler argument is null.
  See Also:
    `XMLReader.getDTDHandler()`

### getDTDHandler

    public org.xml.sax.DTDHandler getDTDHandler()

  Description copied from interface: `org.xml.sax.XMLReader`
  Return the current DTD handler.
  Specified by:
    `getDTDHandler` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Returns:
    The current DTD handler, or null if none has been registered.
  See Also:
    `XMLReader.setDTDHandler(org.xml.sax.DTDHandler)`

### setContentHandler

    public void setContentHandler(org.xml.sax.ContentHandler handler)

  Description copied from interface: `org.xml.sax.XMLReader`
  Allow an application to register a content event handler.

  If the application does not register a content handler, all content events reported by the SAX parser will be silently ignored.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setContentHandler` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Parameters:
    `handler` - The content handler.
  Throws:
    `java.lang.NullPointerException` - If the handler argument is null.
  See Also:
    `XMLReader.getContentHandler()`

### getContentHandler

    public org.xml.sax.ContentHandler getContentHandler()

  Description copied from interface: `org.xml.sax.XMLReader`
  Return the current content handler.
  Specified by:
    `getContentHandler` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Returns:
    The current content handler, or null if none has been registered.
  See Also:
    `XMLReader.setContentHandler(org.xml.sax.ContentHandler)`

### setDocumentHandler

    public void setDocumentHandler(org.xml.sax.DocumentHandler handler)

  Configures the document handler callback.
  Specified by:
    `setDocumentHandler` in interface `org.xml.sax.Parser`
  Parameters:
    `handler` - the new document handler.

### setErrorHandler

    public void setErrorHandler(org.xml.sax.ErrorHandler handler)

  Description copied from interface: `org.xml.sax.XMLReader`
  Allow an application to register an error event handler.

  If the application does not register an error handler, all error events reported by the SAX parser will be silently ignored; however, normal processing may not continue. It is highly recommended that all SAX applications implement an error handler to avoid unexpected bugs.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setErrorHandler` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Parameters:
    `handler` - The error handler.
  Throws:
    `java.lang.NullPointerException` - If the handler argument is null.
  See Also:
    `XMLReader.getErrorHandler()`

### getErrorHandler

    public org.xml.sax.ErrorHandler getErrorHandler()

  Description copied from interface: `org.xml.sax.XMLReader`
  Return the current error handler.
  Specified by:
    `getErrorHandler` in interface `org.xml.sax.XMLReader`
  Following copied from interface: `org.xml.sax.XMLReader`
  Returns:
    The current error handler, or null if none has been registered.
  See Also:
    `XMLReader.setErrorHandler(org.xml.sax.ErrorHandler)`

### setLocale

    public void setLocale(java.util.Locale locale)

  Description copied from interface: `org.xml.sax.Parser`
  Allow an application to request a locale for errors and warnings.

  SAX parsers are not required to provide localisation for errors and warnings; if they cannot support the requested locale, however, they must throw a SAX exception. Applications may not request a locale change in the middle of a parse.

  Specified by:
    `setLocale` in interface `org.xml.sax.Parser`
  Following copied from interface: `org.xml.sax.Parser`
  Parameters:
    `locale` - A Java Locale object.
  Throws:
    `org.xml.sax.SAXException` - Throws an exception (using the previous or default locale) if the requested locale is not supported.
  See Also:
    `SAXException`, `SAXParseException`

### parse

    public void parse(org.xml.sax.InputSource source)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  SAX parsing from a SAX InputSource
  Specified by:
    `parse` in interface `org.xml.sax.XMLReader`
  Parameters:
    `source` - source containing the XML

### parse

    public void parse(java.io.InputStream is)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  SAX parsing from an InputStream
  Parameters:
    `is` - stream containing the XML

### parse

    public void parse(java.io.InputStream is,
                      java.lang.String systemId)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  SAX parsing from an InputStream
  Parameters:
    `is` - stream containing the XML

### parse

    public void parse(java.lang.String systemId)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  SAX parsing from a file path
  Specified by:
    `parse` in interface `org.xml.sax.XMLReader`
  Parameters:
    `systemId` - path to the file containing the XML

### parse

    public void parse(Path path)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  SAX parsing from a VFS path

### parseString

    public void parseString(java.lang.String string)
                     throws java.io.IOException,
                            org.xml.sax.SAXException

  SAX parsing from a string.
  Parameters:
    `string` - string containing the XML

### parseDocument

    public Document parseDocument(org.xml.sax.InputSource source)
                           throws java.io.IOException,
                                  org.xml.sax.SAXException

  Parses a document from a SAX InputSource
  Parameters:
    `source` - SAX InputSource containing the XML data.

### parseDocument

    public Document parseDocument(java.lang.String systemId)
                           throws java.io.IOException,
                                  org.xml.sax.SAXException

  Parses a document from system path.
  Parameters:
    `systemId` - path to the XML data.

### parseDocument

    public Document parseDocument(Path path)
                           throws java.io.IOException,
                                  org.xml.sax.SAXException

  Parses a document from a VFS path
  Parameters:
    `path` - the VFS path containing the XML document.

### parseDocument

    public Document parseDocument(java.io.InputStream is)
                           throws java.io.IOException,
                                  org.xml.sax.SAXException

  Parses an input stream into a DOM document
  Parameters:
    `is` - the input stream containing the XML
  Returns:
    the parsed document.

### parseDocument

    public Document parseDocument(java.io.InputStream is,
                                  java.lang.String systemId)
                           throws java.io.IOException,
                                  org.xml.sax.SAXException

  Parses an input stream into a DOM document
  Parameters:
    `is` - the input stream containing the XML
    `systemId` - the URL of the stream.
  Returns:
    the parsed document.

### parseDocumentString

    public Document parseDocumentString(java.lang.String string)
                                 throws java.io.IOException,
                                        org.xml.sax.SAXException

  Parses a string into a DOM document
  Parameters:
    `string` - the string containing the XML

### openStream

    public java.io.InputStream openStream(java.lang.String systemId,
                                          java.lang.String publicId)
                                   throws java.io.IOException,
                                          org.xml.sax.SAXException

  Looks up an input stream from the system id.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD